#ifndef ARCHIVE_DEPENDENCY_H
#define ARCHIVE_DEPENDENCY_H

#include <string>
#include <optional>
#include <nlohmann/json.hpp>

#ifndef LAUNCHPAD_API
#ifdef BUILDING_LAUNCHPAD
  #define LAUNCHPAD_API __attribute__((visibility("default")))
#else
  #define LAUNCHPAD_API
#endif
#endif

class launchpad;

class archive_dependency {
public:
    archive_dependency();
    ~archive_dependency();

    static std::optional<archive_dependency> parse(const std::string& json_data);
    void parse_json(const std::string& json_data);
    void set_lp(launchpad* lp_ptr);

    std::string archive_link;
    std::string component_name;
    std::string date_created;
    std::string dependency_link;
    std::string http_etag;
    std::string pocket;
    std::string resource_type_link;
    std::string self_link;
    std::string snap_base_link;
    std::string title;

    std::optional<archive_dependency> get() const;
    bool patch(const nlohmann::json& data) const;
    bool put(const nlohmann::json& data) const;

private:
    launchpad* lp;
};

#endif
