#ifndef DISTRO_ARCH_SERIES_FILTER_H
#define DISTRO_ARCH_SERIES_FILTER_H

#include <string>
#include <optional>
#include <nlohmann/json.hpp>

#ifndef LAUNCHPAD_API
#ifdef BUILDING_LAUNCHPAD
  #define LAUNCHPAD_API __attribute__((visibility("default")))
#else
  #define LAUNCHPAD_API
#endif
#endif

class launchpad;

class distro_arch_series_filter {
public:
    distro_arch_series_filter();
    ~distro_arch_series_filter();

    static std::optional<distro_arch_series_filter> parse(const std::string& json_data);
    void parse_json(const std::string& json_data);
    void set_lp(launchpad* lp_ptr);

    // Read-only fields
    std::string creator_link;
    std::string date_created;
    std::string date_last_modified;
    std::string distroarchseries_link;
    std::string http_etag;
    std::string packageset_link;
    std::string resource_type_link;
    std::string self_link;
    std::string sense; // "Include" or "Exclude"
    std::string web_link;

    std::optional<distro_arch_series_filter> get() const;
    bool patch(const nlohmann::json& data) const;
    bool put(const nlohmann::json& data) const;

private:
    launchpad* lp;
};

#endif
